#pragma warning (disable : 4996)
//Only Square matrix is solvable!!!

#include "cg_spl.h"
#include "coord_double.h"
#include "ilupre_double.h"
#include "mvm.h"

CG_SPL::CG_SPL(const char fileA[], const char fileb[], double _tol, int _maxit){
	tol = _tol;
	result = 0;
	maxit = _maxit;
	A = new CompCol_Mat_double;
	Coord_Mat_double t;
	readtxtfile_mat(fileA, &t);
	*A = t;
	b = new VECTOR_double;	
	readtxtfile_vec(fileb, b);
	x = new VECTOR_double(A->dim(1), 0.0);
	D = new DiagPreconditioner_double(*A);
}

CG_SPL::CG_SPL(Coord_Mat_double *mA, VECTOR_double *vb, VECTOR_double *vx, double _tol, int _maxit){
	tol = _tol;
	result = 0;
	maxit = _maxit;
	A = new CompCol_Mat_double(*mA);
	b = new VECTOR_double(*vb);
	x = new VECTOR_double(*vx);
	///if (b->dim_ != x->dim_)
	//	D = NULL;
	//else
	D = new DiagPreconditioner_double(*A);
}

CG_SPL::CG_SPL(const char fileA[], const char fileb[], const char initx[], double _tol, int _maxit){
	tol = _tol;
	result = 0;
	maxit = _maxit;
	A = new CompCol_Mat_double;
	Coord_Mat_double t;
	readtxtfile_mat(fileA, &t);
	*A = t;
	b = new VECTOR_double;	
	readtxtfile_vec(fileb, b);
	x = new VECTOR_double(A->dim(1), 0.0);
	int i;
	float tempx;
	FILE * fpx = fopen(initx, "r");
	if (fpx == NULL)
		exit(0);
	for (i=0; i<A->dim(1); ++i){
		fscanf(fpx, "%f\n", &tempx);
		(*x)(i) = tempx;
	}
	fclose(fpx);
	D = new DiagPreconditioner_double(*A);
}

CG_SPL::~CG_SPL(){
	delete A;
	delete b;
	delete x;
	//if (D)
	delete D;
}

void CG_SPL::Convert()
{

}

void CG_SPL::solve_BiCG(const char filex[]){
	result = BiCG(*A, *x, *b, *D, maxit, tol);
	writetxtfile_vec(filex, *x);
}

void CG_SPL::solve_BiCGSTAB(const char filex[]){
	result = BiCGSTAB(*A, *x, *b, *D, maxit, tol);
	writetxtfile_vec(filex, *x);
}

void CG_SPL::solve_CGS(const char filex[]){
	result = CGS(*A, *x, *b, *D, maxit, tol);
	writetxtfile_vec(filex, *x);
}

void CG_SPL::solve_QMR(const char filex[]){
	result = QMR(*A, *x, *b, *D, *D, maxit, tol);
	writetxtfile_vec(filex, *x);
}

void CG_SPL::solve_IR(const char filex[]){
	result = IR(*A, *x, *b, *D, maxit, tol);
	writetxtfile_vec(filex, *x);
}

void CG_SPL::solve_GMRES(const char filex[]){
	int restart = 32;
	MATRIX_double H(restart+1, restart, 0.0);
	CompCol_ILUPreconditioner_double M(*A);
	result = GMRES(*A, *x, *b, M, H, restart, maxit, tol);
	writetxtfile_vec(filex, *x);
}

