
//Only Square matrix is solvable!!!

#ifndef CG_SPL_H
#define CG_SPL_H

#include <stdlib.h>
#include <iostream>

#include "compcol_double.h"
#include "iohb_double.h"
#include "iotext_double.h"
#include "mvblasd.h"
#include "diagpre_double.h"

#include "bicg.h"
#include "bicgstab.h"
#include "cgs.h"
#include "qmr.h"
#include "ir.h"
#include "gmres.h"

class CG_SPL{
public:
	CG_SPL(const char fileA[], const char fileb[], double _tol, int _maxit);
	CG_SPL(const char fileA[], const char fileb[], const char initx[], double _tol, int _maxit);
	CG_SPL(Coord_Mat_double *mA, VECTOR_double *vb, VECTOR_double *vx, double _tol, int _maxit);
	~CG_SPL();

	void Convert();

	void solve_BiCG(const char filex[]);
	void solve_BiCGSTAB(const char filex[]);
	void solve_CGS(const char filex[]);
	void solve_QMR(const char filex[]);
	void solve_IR(const char filex[]);
	void solve_GMRES(const char filex[]);

	double tol;
	int result;
	int maxit;
	CompCol_Mat_double *A;
	VECTOR_double *b;
	VECTOR_double *x;
	DiagPreconditioner_double *D;
};

#endif
