#include "../Core_Mesh/Mesh.h"
#include "../Core_Mesh/Loop.h"

namespace XMeshLib
{
	class Map2Rect
	{
	public:
		Map2Rect(Mesh * inmesh, Vertex * corners[4])
		{ 
			cmesh = inmesh; 
			cornerV[0] = corners[0];
			cornerV[1] = corners[1];
			cornerV[2] = corners[2];
			cornerV[3] = corners[3];
		}
		~Map2Rect(){;}
		void Parameterize(double u0, double v0, double u1, double v1, double u2, double v2, double u3, double v3,
			const char outfile[], Loop & bLoop, double loopLength);
		
	protected:
		void _1_SetCornerUV(double u0=0, double v0=0, double u1=1, double v1=0, double u2=1, double v2=1, double u3=0, double v3=1);
		void _2_PrepareWeights();
		void _3_ParameterizeBoundaryUV(Loop & bLoop, double loopLength);
		void _4_SolveInteriorUV();
		void _5_WriteMesh(const char file[]);

		void SetHarmonicWeights();
		void ComputeCornerAngle();

	protected:
		Mesh * cmesh;
		Vertex * cornerV[4];

	protected:
		//precomputed properties
		stdext::hash_map<Halfedge *, double> HEAngles;  // corner angle of the target vertex
		stdext::hash_map<Edge *, double> EWeights; //weight on each edge
		stdext::hash_map<Vertex *, double> WeightSums; //summation of weights on a vertex
	public:
		stdext::hash_map<Vertex *, double> texU; //UV values on each vertex
		stdext::hash_map<Vertex *, double> texV;
	};
}

//Map2Rect(const char file1[], int vID[4]);
//Map2Rect(const char file1[], int firstVID);
//Check (1) whether the input mesh is topological disk, (2) whether input vertex IDs are valid
//bool CheckValidity();	
//void Process(const char outfile[], WeightTypes wtp=Harmonic);		void SetTutteWeights();
//void SetMeanValueWeights();
